# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

#########################

# change 'tests => 1' to 'tests => last_test_to_print';

use Test;
BEGIN { plan tests => 1 };
use LJperl;
ok(1); # If we made it this far, we're ok.

$errcode = 0;
$id      = 0;

#########################
# Insert your test code below, the Test module is use()ed here so read
# its man page ( perldoc Test ) for help writing this test script.

$ch   = 0;
$gain = 0;

($errcode, $id, $oV, $V) = LJperl::EAnalogIn($idnum, $demo, $ch, $gain);

print "EAnalogIn\nResult:\t= $oV\n\t= $V\n";
##############################################################################
#($errcode,$id) = EAnalogOut($idnum, $demo, $analogOut0, $analogOut1);
#
#print "EAnalogIn\nResult:\t= $errcode\n\t= $id\n";
##############################################################################
(undef, undef, $a, $b) = LJperl::ECount($idnum, $demo, 0);

print "ECount\nCount\t= $a ($b)\n";
##############################################################################
#(err, id, result) = LJperl::nDigitalIn(id, IOx, ReadD);
(undef, undef, $a) = LJperl::EDigitalIn($idnum, 0, 0);
(undef, undef, $b) = LJperl::EDigitalIn($idnum, 1, 0);
(undef, undef, $c) = LJperl::EDigitalIn($idnum, 2, 0);
(undef, undef, $d) = LJperl::EDigitalIn($idnum, 3, 0);

print "EDigitalIn\nI0-3\t= $a$b$c$d\n";
##############################################################################
#($errcode, $id) = EDigitalOut($idnum, $demo, $channel, $writeD, $state);
#
#print "EAnalogOut\nResult:\t= $errcode\n\t= $id\n";
##############################################################################
$stateIO	= 0;
$updateIO	= 0;
$ledOn		= 1;
@channels	= (0,1,2,3);
@gains		= (0,0,0,0);
$disableCal	= 0;

my($t, undef, $s, undef, @results) = LJperl::AISample($idnum,$demo,$stateIO,$updateIO,$ledOn,\@channels,\@gains,$disableCal);

print "AISample\n";
print join("\n",("",@results)) . "\n";
##############################################################################
#($errcode,$idnum,$stateD,$stateIO,$count) = AOUpdate($idnum,$demo,$trisD,$trisIO,$stateD,$stateIO,$updateDigital,$resetCounter,$count,$analogOut0,$analogOut1)
#
#print "EAnalogOut\nResult:\t= $errcode\n\t= $id\n";
##############################################################################
#($errcode,$volts) = BitsToVolts($chnum, $chgain, $bits);
##############################################################################
#($errcode,$volts) = VoltsToBits($chnum, $chgain, $volts);
##############################################################################
@stateD  = (0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
@stIO    = (0, 0, 0, 0);
@counter = ( 1 );

$resetcounter = 0;
$enableSTB    = 0;

($a, $b, $statD, $statIO, $cnt) = LJperl::Counter($idnum, 0, \@stateD, \@stIO, $resetcounter, $enableSTB, \@counter);

print "Results:= $a\n\t= $b\n\t= $cnt\n\t= @stateD ($statD)\n\t= @stIO ($statIO)\n\t= $cnt\n";

##############################################################################
$TD = 0;
$SD = 0;
$SI = 0;
$OD = 0;

($err, $id, $tri, $sD, $sIO, $oD) = LJperl::DigitalIO($idnum, $demo, $TD, $trisIO, $SD, $SI, $updateDigital);

print "Result:\t= $err\n\t= $id\n\t= $tri\n\t= $sD\n\t= $sIO\n\t= $oD\n";
##############################################################################
$a = LJperl::GetDriverVersion();

print "Ver:\t= $a\n";

##############################################################################
$a = LJperl::GetErrorString(0);

print "Str:\t= $a\n";

##############################################################################
($err, $a, $b, $c, $d, $e, $f) = LJperl::GetWinVersion();

print "WVer\nmajor    = $a\nminor    = $b\nbuild    = $c\nplatform = $d\nPack maj = $e\nPack min = $f\n";
##############################################################################
($a, $b) = LJperl::GetFirmwareVersion($idnum);

$a = $a/1000;

print "Firware version: $a\n";
##############################################################################
#($errcode,$id) = Watchdog($idnum, $demo, $active, $timeout, $reset, $activeD0, $activeD1, $activeD8, $stateD0, $stateD1, $stateD8)'
##############################################################################
$err = LJperl::WriteMem($idnum, 0, 512, 3, 2, 1, 126);

print "Err:\t= $err\n";
##############################################################################
($err, $id, $d0, $d1, $d2, $d3) = LJperl::ReadMem($idnum, 512);

print "Result:\t = $id\n\t= $d0\n\t= $d1\n\t= $d2\n\t= $d3\n";
##############################################################################
